##// END OF EJS Templates
.
Unknown -
r353:640527d70532
parent child
Show More
@@ -1,830 +1,830
1 #!/bin/bash
1 #!/bin/bash
2 ########################################################################
2 ########################################################################
3 # rpi23-gen-image.sh 2015-2017
3 # rpi23-gen-image.sh 2015-2017
4 #
4 #
5 # Advanced Debian "stretch" and "buster" bootstrap script for RPi2/3
5 # Advanced Debian "stretch" and "buster" bootstrap script for RPi2/3
6 #
6 #
7 # This program is free software; you can redistribute it and/or
7 # This program is free software; you can redistribute it and/or
8 # modify it under the terms of the GNU General Public License
8 # modify it under the terms of the GNU General Public License
9 # as published by the Free Software Foundation; either version 2
9 # as published by the Free Software Foundation; either version 2
10 # of the License, or (at your option) any later version.
10 # of the License, or (at your option) any later version.
11 #
11 #
12 # Copyright (C) 2015 Jan Wagner <mail@jwagner.eu>
12 # Copyright (C) 2015 Jan Wagner <mail@jwagner.eu>
13 #
13 #
14 # Big thanks for patches and enhancements by 20+ github contributors!
14 # Big thanks for patches and enhancements by 20+ github contributors!
15 ########################################################################
15 ########################################################################
16
16
17 # Are we running as root?
17 # Are we running as root?
18 if [ "$(id -u)" -ne "0" ] ; then
18 if [ "$(id -u)" -ne "0" ] ; then
19 echo "error: this script must be executed with root privileges!"
19 echo "error: this script must be executed with root privileges!"
20 exit 1
20 exit 1
21 fi
21 fi
22
22
23 # Check if ./functions.sh script exists
23 # Check if ./functions.sh script exists
24 if [ ! -r "./functions.sh" ] ; then
24 if [ ! -r "./functions.sh" ] ; then
25 echo "error: './functions.sh' required script not found!"
25 echo "error: './functions.sh' required script not found!"
26 exit 1
26 exit 1
27 fi
27 fi
28
28
29 # Load utility functions
29 # Load utility functions
30 . ./functions.sh
30 . ./functions.sh
31
31
32 # Load parameters from configuration template file
32 # Load parameters from configuration template file
33 if [ -n "$CONFIG_TEMPLATE" ] ; then
33 if [ -n "$CONFIG_TEMPLATE" ] ; then
34 use_template
34 use_template
35 fi
35 fi
36
36
37 # Introduce settings
37 # Introduce settings
38 set -e
38 set -e
39 echo -n -e "\n#\n# RPi2/3 Bootstrap Settings\n#\n"
39 echo -n -e "\n#\n# RPi2/3 Bootstrap Settings\n#\n"
40 set -x
40 set -x
41
41
42 # Raspberry Pi model configuration
42 # Raspberry Pi model configuration
43 export RPI_MODEL=${RPI_MODEL:=2}
43 export RPI_MODEL=${RPI_MODEL:=2}
44
44
45 # Debian release
45 # Debian release
46 export RELEASE=${RELEASE:=buster}
46 export RELEASE=${RELEASE:=buster}
47
47
48 #Kernel Branch
48 #Kernel Branch
49 export KERNEL_BRANCH=${KERNEL_BRANCH:=""}
49 export KERNEL_BRANCH=${KERNEL_BRANCH:=""}
50
50
51 # URLs
51 # URLs
52 KERNEL_URL=${KERNEL_URL:=https://github.com/raspberrypi/linux}
52 KERNEL_URL=${KERNEL_URL:=https://github.com/raspberrypi/linux}
53 FIRMWARE_URL=${FIRMWARE_URL:=https://github.com/raspberrypi/firmware/raw/master/boot}
53 FIRMWARE_URL=${FIRMWARE_URL:=https://github.com/raspberrypi/firmware/raw/master/boot}
54 WLAN_FIRMWARE_URL=${WLAN_FIRMWARE_URL:=https://github.com/RPi-Distro/firmware-nonfree/raw/master/brcm}
54 WLAN_FIRMWARE_URL=${WLAN_FIRMWARE_URL:=https://github.com/RPi-Distro/firmware-nonfree/raw/master/brcm}
55 COLLABORA_URL=${COLLABORA_URL:=https://repositories.collabora.co.uk/debian}
55 COLLABORA_URL=${COLLABORA_URL:=https://repositories.collabora.co.uk/debian}
56 FBTURBO_URL=${FBTURBO_URL:=https://github.com/ssvb/xf86-video-fbturbo.git}
56 FBTURBO_URL=${FBTURBO_URL:=https://github.com/ssvb/xf86-video-fbturbo.git}
57 UBOOT_URL=${UBOOT_URL:=https://git.denx.de/u-boot.git}
57 UBOOT_URL=${UBOOT_URL:=https://git.denx.de/u-boot.git}
58 VIDEOCORE_URL=${VIDEOCORE_URL:=https://github.com/raspberrypi/userland}
58 VIDEOCORE_URL=${VIDEOCORE_URL:=https://github.com/raspberrypi/userland}
59 #BIS= Kernel has KVM and zswap enabled
59 #BIS= Kernel has KVM and zswap enabled
60 RPI3_64_BIS_KERNEL_URL=${RPI3_64_BIS_KERNEL_URL:=https://github.com/sakaki-/bcmrpi3-kernel-bis/releases/download/4.14.80.20181113/bcmrpi3-kernel-bis-4.14.80.20181113.tar.xz}
60 RPI3_64_BIS_KERNEL_URL=${RPI3_64_BIS_KERNEL_URL:=https://github.com/sakaki-/bcmrpi3-kernel-bis/releases/download/4.14.80.20181113/bcmrpi3-kernel-bis-4.14.80.20181113.tar.xz}
61 #default bcmrpi3_defconfig target kernel
61 #default bcmrpi3_defconfig target kernel
62 RPI3_64_DEF_KERNEL_URL=${RPI3_64_DEF_KERNEL_URL:=https://github.com/sakaki-/bcmrpi3-kernel/releases/download/4.14.80.20181113/bcmrpi3-kernel-4.14.80.20181113.tar.xz}
62 RPI3_64_DEF_KERNEL_URL=${RPI3_64_DEF_KERNEL_URL:=https://github.com/sakaki-/bcmrpi3-kernel/releases/download/4.14.80.20181113/bcmrpi3-kernel-4.14.80.20181113.tar.xz}
63 #enhanced kernel
63 #enhanced kernel
64 RPI3_64_KERNEL_URL=${RPI3_64_KERNEL_URL:=$RPI3_64_BIS_KERNEL_URL}
64 RPI3_64_KERNEL_URL=${RPI3_64_KERNEL_URL:=$RPI3_64_BIS_KERNEL_URL}
65 #https://aur.archlinux.org/packages/pi-bluetooth/
65 #https://aur.archlinux.org/packages/pi-bluetooth/
66 BLUETOOTH_URL=${BLUETOOTH_URL:=https://aur.archlinux.org/pi-bluetooth.git}
66 BLUETOOTH_URL=${BLUETOOTH_URL:=https://aur.archlinux.org/pi-bluetooth.git}
67
67
68 # Build directories
68 # Build directories
69 BASEDIR=${BASEDIR:=$(pwd)/images/${RELEASE}}
69 BASEDIR=${BASEDIR:=$(pwd)/images/${RELEASE}}
70 BUILDDIR="${BASEDIR}/build"
70 BUILDDIR="${BASEDIR}/build"
71
71
72 # Prepare date string for default image file name
72 # Prepare date string for default image file name
73 DATE="$(date +%Y-%m-%d)"
73 DATE="$(date +%Y-%m-%d)"
74 if [ -z "$KERNEL_BRANCH" ] ; then
74 if [ -z "$KERNEL_BRANCH" ] ; then
75 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
75 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
76 else
76 else
77 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-${KERNEL_BRANCH}-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
77 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-${KERNEL_BRANCH}-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
78 fi
78 fi
79
79
80 # Chroot directories
80 # Chroot directories
81 R="${BUILDDIR}/chroot"
81 R="${BUILDDIR}/chroot"
82 ETC_DIR="${R}/etc"
82 ETC_DIR="${R}/etc"
83 LIB_DIR="${R}/lib"
83 LIB_DIR="${R}/lib"
84 BOOT_DIR="${R}/boot/firmware"
84 BOOT_DIR="${R}/boot/firmware"
85 KERNEL_DIR="${R}/usr/src/linux"
85 KERNEL_DIR="${R}/usr/src/linux"
86 WLAN_FIRMWARE_DIR="${R}/lib/firmware/brcm"
86 WLAN_FIRMWARE_DIR="${R}/lib/firmware/brcm"
87
87
88 # Firmware directory: Blank if download from github
88 # Firmware directory: Blank if download from github
89 RPI_FIRMWARE_DIR=${RPI_FIRMWARE_DIR:=""}
89 RPI_FIRMWARE_DIR=${RPI_FIRMWARE_DIR:=""}
90 # General settings
90 # General settings
91 SET_ARCH=${SET_ARCH:=32}
91 SET_ARCH=${SET_ARCH:=32}
92 HOSTNAME=${HOSTNAME:=rpi${RPI_MODEL}-${RELEASE}}
92 HOSTNAME=${HOSTNAME:=rpi${RPI_MODEL}-${RELEASE}}
93 PASSWORD=${PASSWORD:=raspberry}
93 PASSWORD=${PASSWORD:=raspberry}
94 USER_PASSWORD=${USER_PASSWORD:=raspberry}
94 USER_PASSWORD=${USER_PASSWORD:=raspberry}
95 DEFLOCAL=${DEFLOCAL:="en_US.UTF-8"}
95 DEFLOCAL=${DEFLOCAL:="en_US.UTF-8"}
96 TIMEZONE=${TIMEZONE:="Europe/Berlin"}
96 TIMEZONE=${TIMEZONE:="Europe/Berlin"}
97 EXPANDROOT=${EXPANDROOT:=true}
97 EXPANDROOT=${EXPANDROOT:=true}
98
98
99 # Keyboard settings
99 # Keyboard settings
100 XKB_MODEL=${XKB_MODEL:=""}
100 XKB_MODEL=${XKB_MODEL:=""}
101 XKB_LAYOUT=${XKB_LAYOUT:=""}
101 XKB_LAYOUT=${XKB_LAYOUT:=""}
102 XKB_VARIANT=${XKB_VARIANT:=""}
102 XKB_VARIANT=${XKB_VARIANT:=""}
103 XKB_OPTIONS=${XKB_OPTIONS:=""}
103 XKB_OPTIONS=${XKB_OPTIONS:=""}
104
104
105 # Network settings (DHCP)
105 # Network settings (DHCP)
106 ENABLE_DHCP=${ENABLE_DHCP:=true}
106 ENABLE_DHCP=${ENABLE_DHCP:=true}
107
107
108 # Network settings (static)
108 # Network settings (static)
109 NET_ADDRESS=${NET_ADDRESS:=""}
109 NET_ADDRESS=${NET_ADDRESS:=""}
110 NET_GATEWAY=${NET_GATEWAY:=""}
110 NET_GATEWAY=${NET_GATEWAY:=""}
111 NET_DNS_1=${NET_DNS_1:=""}
111 NET_DNS_1=${NET_DNS_1:=""}
112 NET_DNS_2=${NET_DNS_2:=""}
112 NET_DNS_2=${NET_DNS_2:=""}
113 NET_DNS_DOMAINS=${NET_DNS_DOMAINS:=""}
113 NET_DNS_DOMAINS=${NET_DNS_DOMAINS:=""}
114 NET_NTP_1=${NET_NTP_1:=""}
114 NET_NTP_1=${NET_NTP_1:=""}
115 NET_NTP_2=${NET_NTP_2:=""}
115 NET_NTP_2=${NET_NTP_2:=""}
116
116
117 # APT settings
117 # APT settings
118 APT_PROXY=${APT_PROXY:=""}
118 APT_PROXY=${APT_PROXY:=""}
119 APT_SERVER=${APT_SERVER:="ftp.debian.org"}
119 APT_SERVER=${APT_SERVER:="ftp.debian.org"}
120
120
121 # Feature settings
121 # Feature settings
122 ENABLE_CONSOLE=${ENABLE_CONSOLE:=true}
122 ENABLE_CONSOLE=${ENABLE_CONSOLE:=true}
123 ENABLE_I2C=${ENABLE_I2C:=false}
123 ENABLE_I2C=${ENABLE_I2C:=false}
124 ENABLE_SPI=${ENABLE_SPI:=false}
124 ENABLE_SPI=${ENABLE_SPI:=false}
125 ENABLE_IPV6=${ENABLE_IPV6:=true}
125 ENABLE_IPV6=${ENABLE_IPV6:=true}
126 ENABLE_SSHD=${ENABLE_SSHD:=true}
126 ENABLE_SSHD=${ENABLE_SSHD:=true}
127 ENABLE_NONFREE=${ENABLE_NONFREE:=false}
127 ENABLE_NONFREE=${ENABLE_NONFREE:=false}
128 ENABLE_WIRELESS=${ENABLE_WIRELESS:=false}
128 ENABLE_WIRELESS=${ENABLE_WIRELESS:=false}
129 ENABLE_SOUND=${ENABLE_SOUND:=true}
129 ENABLE_SOUND=${ENABLE_SOUND:=true}
130 ENABLE_DBUS=${ENABLE_DBUS:=true}
130 ENABLE_DBUS=${ENABLE_DBUS:=true}
131 ENABLE_HWRANDOM=${ENABLE_HWRANDOM:=true}
131 ENABLE_HWRANDOM=${ENABLE_HWRANDOM:=true}
132 ENABLE_MINGPU=${ENABLE_MINGPU:=false}
132 ENABLE_MINGPU=${ENABLE_MINGPU:=false}
133 ENABLE_XORG=${ENABLE_XORG:=false}
133 ENABLE_XORG=${ENABLE_XORG:=false}
134 ENABLE_WM=${ENABLE_WM:=""}
134 ENABLE_WM=${ENABLE_WM:=""}
135 ENABLE_RSYSLOG=${ENABLE_RSYSLOG:=true}
135 ENABLE_RSYSLOG=${ENABLE_RSYSLOG:=true}
136 ENABLE_USER=${ENABLE_USER:=true}
136 ENABLE_USER=${ENABLE_USER:=true}
137 USER_NAME=${USER_NAME:="pi"}
137 USER_NAME=${USER_NAME:="pi"}
138 ENABLE_ROOT=${ENABLE_ROOT:=false}
138 ENABLE_ROOT=${ENABLE_ROOT:=false}
139 ENABLE_QEMU=${ENABLE_QEMU:=false}
139 ENABLE_QEMU=${ENABLE_QEMU:=false}
140 ENABLE_SYSVINIT=${ENABLE_SYSVINIT:=false}
140 ENABLE_SYSVINIT=${ENABLE_SYSVINIT:=false}
141
141
142 # SSH settings
142 # SSH settings
143 SSH_ENABLE_ROOT=${SSH_ENABLE_ROOT:=false}
143 SSH_ENABLE_ROOT=${SSH_ENABLE_ROOT:=false}
144 SSH_DISABLE_PASSWORD_AUTH=${SSH_DISABLE_PASSWORD_AUTH:=false}
144 SSH_DISABLE_PASSWORD_AUTH=${SSH_DISABLE_PASSWORD_AUTH:=false}
145 SSH_LIMIT_USERS=${SSH_LIMIT_USERS:=false}
145 SSH_LIMIT_USERS=${SSH_LIMIT_USERS:=false}
146 SSH_ROOT_PUB_KEY=${SSH_ROOT_PUB_KEY:=""}
146 SSH_ROOT_PUB_KEY=${SSH_ROOT_PUB_KEY:=""}
147 SSH_USER_PUB_KEY=${SSH_USER_PUB_KEY:=""}
147 SSH_USER_PUB_KEY=${SSH_USER_PUB_KEY:=""}
148
148
149 # Advanced settings
149 # Advanced settings
150 ENABLE_MINBASE=${ENABLE_MINBASE:=false}
150 ENABLE_MINBASE=${ENABLE_MINBASE:=false}
151 ENABLE_REDUCE=${ENABLE_REDUCE:=false}
151 ENABLE_REDUCE=${ENABLE_REDUCE:=false}
152 ENABLE_UBOOT=${ENABLE_UBOOT:=false}
152 ENABLE_UBOOT=${ENABLE_UBOOT:=false}
153 UBOOTSRC_DIR=${UBOOTSRC_DIR:=""}
153 UBOOTSRC_DIR=${UBOOTSRC_DIR:=""}
154 ENABLE_UBOOTUSB=${ENABLE_UBOOTUSB=false}
154 ENABLE_UBOOTUSB=${ENABLE_UBOOTUSB=false}
155 ENABLE_FBTURBO=${ENABLE_FBTURBO:=false}
155 ENABLE_FBTURBO=${ENABLE_FBTURBO:=false}
156 ENABLE_VIDEOCORE=${ENABLE_VIDEOCORE:=true}
156 ENABLE_VIDEOCORE=${ENABLE_VIDEOCORE:=true}
157 VIDEOCORESRC_DIR=${VIDEOCORESRC_DIR:=""}
157 VIDEOCORESRC_DIR=${VIDEOCORESRC_DIR:=""}
158 FBTURBOSRC_DIR=${FBTURBOSRC_DIR:=""}
158 FBTURBOSRC_DIR=${FBTURBOSRC_DIR:=""}
159 ENABLE_HARDNET=${ENABLE_HARDNET:=false}
159 ENABLE_HARDNET=${ENABLE_HARDNET:=false}
160 ENABLE_IPTABLES=${ENABLE_IPTABLES:=false}
160 ENABLE_IPTABLES=${ENABLE_IPTABLES:=false}
161 ENABLE_SPLITFS=${ENABLE_SPLITFS:=false}
161 ENABLE_SPLITFS=${ENABLE_SPLITFS:=false}
162 ENABLE_INITRAMFS=${ENABLE_INITRAMFS:=false}
162 ENABLE_INITRAMFS=${ENABLE_INITRAMFS:=false}
163 ENABLE_IFNAMES=${ENABLE_IFNAMES:=true}
163 ENABLE_IFNAMES=${ENABLE_IFNAMES:=true}
164 DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS:=}
164 DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS:=}
165
165
166 # Kernel compilation settings
166 # Kernel compilation settings
167 BUILD_KERNEL=${BUILD_KERNEL:=true}
167 BUILD_KERNEL=${BUILD_KERNEL:=true}
168 KERNEL_REDUCE=${KERNEL_REDUCE:=false}
168 KERNEL_REDUCE=${KERNEL_REDUCE:=false}
169 KERNEL_THREADS=${KERNEL_THREADS:=1}
169 KERNEL_THREADS=${KERNEL_THREADS:=1}
170 KERNEL_HEADERS=${KERNEL_HEADERS:=true}
170 KERNEL_HEADERS=${KERNEL_HEADERS:=true}
171 KERNEL_MENUCONFIG=${KERNEL_MENUCONFIG:=false}
171 KERNEL_MENUCONFIG=${KERNEL_MENUCONFIG:=false}
172 KERNEL_REMOVESRC=${KERNEL_REMOVESRC:=true}
172 KERNEL_REMOVESRC=${KERNEL_REMOVESRC:=true}
173 KERNEL_OLDDEFCONFIG=${KERNEL_OLDDEFCONFIG:=false}
173 KERNEL_OLDDEFCONFIG=${KERNEL_OLDDEFCONFIG:=false}
174 KERNEL_CCACHE=${KERNEL_CCACHE:=false}
174 KERNEL_CCACHE=${KERNEL_CCACHE:=false}
175 KERNEL_ZSWAP=${KERNEL_ZSWAP:=false}
175 KERNEL_ZSWAP=${KERNEL_ZSWAP:=false}
176 KERNEL_VIRT=${KERNEL_VIRT:=false}
176 KERNEL_VIRT=${KERNEL_VIRT:=false}
177 KERNEL_BPF${KERNEL_BPF:=true}
177 KERNEL_BPF=${KERNEL_BPF:=true}
178
178
179 # Kernel compilation from source directory settings
179 # Kernel compilation from source directory settings
180 KERNELSRC_DIR=${KERNELSRC_DIR:=""}
180 KERNELSRC_DIR=${KERNELSRC_DIR:=""}
181 KERNELSRC_CLEAN=${KERNELSRC_CLEAN:=false}
181 KERNELSRC_CLEAN=${KERNELSRC_CLEAN:=false}
182 KERNELSRC_CONFIG=${KERNELSRC_CONFIG:=true}
182 KERNELSRC_CONFIG=${KERNELSRC_CONFIG:=true}
183 KERNELSRC_PREBUILT=${KERNELSRC_PREBUILT:=false}
183 KERNELSRC_PREBUILT=${KERNELSRC_PREBUILT:=false}
184
184
185 # Reduce disk usage settings
185 # Reduce disk usage settings
186 REDUCE_APT=${REDUCE_APT:=true}
186 REDUCE_APT=${REDUCE_APT:=true}
187 REDUCE_DOC=${REDUCE_DOC:=true}
187 REDUCE_DOC=${REDUCE_DOC:=true}
188 REDUCE_MAN=${REDUCE_MAN:=true}
188 REDUCE_MAN=${REDUCE_MAN:=true}
189 REDUCE_VIM=${REDUCE_VIM:=false}
189 REDUCE_VIM=${REDUCE_VIM:=false}
190 REDUCE_BASH=${REDUCE_BASH:=false}
190 REDUCE_BASH=${REDUCE_BASH:=false}
191 REDUCE_HWDB=${REDUCE_HWDB:=true}
191 REDUCE_HWDB=${REDUCE_HWDB:=true}
192 REDUCE_SSHD=${REDUCE_SSHD:=true}
192 REDUCE_SSHD=${REDUCE_SSHD:=true}
193 REDUCE_LOCALE=${REDUCE_LOCALE:=true}
193 REDUCE_LOCALE=${REDUCE_LOCALE:=true}
194
194
195 # Encrypted filesystem settings
195 # Encrypted filesystem settings
196 ENABLE_CRYPTFS=${ENABLE_CRYPTFS:=false}
196 ENABLE_CRYPTFS=${ENABLE_CRYPTFS:=false}
197 CRYPTFS_PASSWORD=${CRYPTFS_PASSWORD:=""}
197 CRYPTFS_PASSWORD=${CRYPTFS_PASSWORD:=""}
198 CRYPTFS_MAPPING=${CRYPTFS_MAPPING:="secure"}
198 CRYPTFS_MAPPING=${CRYPTFS_MAPPING:="secure"}
199 CRYPTFS_CIPHER=${CRYPTFS_CIPHER:="aes-xts-plain64:sha512"}
199 CRYPTFS_CIPHER=${CRYPTFS_CIPHER:="aes-xts-plain64:sha512"}
200 CRYPTFS_XTSKEYSIZE=${CRYPTFS_XTSKEYSIZE:=512}
200 CRYPTFS_XTSKEYSIZE=${CRYPTFS_XTSKEYSIZE:=512}
201
201
202 # Chroot scripts directory
202 # Chroot scripts directory
203 CHROOT_SCRIPTS=${CHROOT_SCRIPTS:=""}
203 CHROOT_SCRIPTS=${CHROOT_SCRIPTS:=""}
204
204
205 # Packages required in the chroot build environment
205 # Packages required in the chroot build environment
206 APT_INCLUDES=${APT_INCLUDES:=""}
206 APT_INCLUDES=${APT_INCLUDES:=""}
207 APT_INCLUDES="${APT_INCLUDES},apt-transport-https,apt-utils,ca-certificates,debian-archive-keyring,dialog,sudo,systemd,sysvinit-utils,locales,keyboard-configuration,console-setup"
207 APT_INCLUDES="${APT_INCLUDES},apt-transport-https,apt-utils,ca-certificates,debian-archive-keyring,dialog,sudo,systemd,sysvinit-utils,locales,keyboard-configuration,console-setup"
208
208
209 #Packages to exclude from chroot build environment
209 #Packages to exclude from chroot build environment
210 APT_EXCLUDES=${APT_EXCLUDES:=""}
210 APT_EXCLUDES=${APT_EXCLUDES:=""}
211
211
212 # Packages required for bootstrapping
212 # Packages required for bootstrapping
213 REQUIRED_PACKAGES="debootstrap debian-archive-keyring qemu-user-static binfmt-support dosfstools rsync bmap-tools whois git bc psmisc dbus sudo netselect-apt"
213 REQUIRED_PACKAGES="debootstrap debian-archive-keyring qemu-user-static binfmt-support dosfstools rsync bmap-tools whois git bc psmisc dbus sudo netselect-apt"
214 MISSING_PACKAGES=""
214 MISSING_PACKAGES=""
215
215
216 # Packages installed for c/c++ build environment in chroot (keep empty)
216 # Packages installed for c/c++ build environment in chroot (keep empty)
217 COMPILER_PACKAGES=""
217 COMPILER_PACKAGES=""
218
218
219 #If init and systemd-sysv are wanted e.g. halt/reboot/shutdown scripts
219 #If init and systemd-sysv are wanted e.g. halt/reboot/shutdown scripts
220 if [ "$ENABLE_SYSVINIT" = false ] ; then
220 if [ "$ENABLE_SYSVINIT" = false ] ; then
221 APT_EXCLUDES="--exclude=${APT_EXCLUDES},init,systemd-sysv"
221 APT_EXCLUDES="--exclude=${APT_EXCLUDES},init,systemd-sysv"
222 fi
222 fi
223
223
224 #Check if apt-cacher-ng has its default port open on and set APT_PROXY
224 #Check if apt-cacher-ng has its default port open on and set APT_PROXY
225 if [ -n "$(lsof -i :3142)" ] ; then
225 if [ -n "$(lsof -i :3142)" ] ; then
226 HTTP_PROXY=http://127.0.0.1:3142/
226 HTTP_PROXY=http://127.0.0.1:3142/
227 fi
227 fi
228
228
229 #ipinfo=$(curl ipinfo.io | grep country )
229 #ipinfo=$(curl ipinfo.io | grep country )
230 #grep -o '\"[^"]*\"' $ipinfo | tr -d '"'
230 #grep -o '\"[^"]*\"' $ipinfo | tr -d '"'
231 #grep -Po '"country":.*?[^\\]",' $(curl ipinfo.io | grep country )
231 #grep -Po '"country":.*?[^\\]",' $(curl ipinfo.io | grep country )
232 #sed -i "s,http:,https:,g" "${ETC_DIR}/apt/sources.list"
232 #sed -i "s,http:,https:,g" "${ETC_DIR}/apt/sources.list"
233 #autconfigure best apt server to not spam ftp.debian.org
233 #autconfigure best apt server to not spam ftp.debian.org
234 #rm files/apt/sources.list
234 #rm files/apt/sources.list
235 #netselect-apt does not know buster yet
235 #netselect-apt does not know buster yet
236 if [ "$RELEASE" = "buster" ] ; then
236 if [ "$RELEASE" = "buster" ] ; then
237 RLS=testing
237 RLS=testing
238 else
238 else
239 RLS="$RELEASE"
239 RLS="$RELEASE"
240 fi
240 fi
241
241
242 if [ -f "$(pwd)/files/apt/sources.list" ] ; then
242 if [ -f "$(pwd)/files/apt/sources.list" ] ; then
243 rm "$(pwd)/files/apt/sources.list"
243 rm "$(pwd)/files/apt/sources.list"
244 fi
244 fi
245
245
246 if [ "$ENABLE_NONFREE" = true ] ; then
246 if [ "$ENABLE_NONFREE" = true ] ; then
247 netselect-apt --arch "$RELEASE_ARCH" --tests 10 --sources --nonfree --outfile "$(pwd)/files/apt/sources.list" -d "$RLS"
247 netselect-apt --arch "$RELEASE_ARCH" --tests 10 --sources --nonfree --outfile "$(pwd)/files/apt/sources.list" -d "$RLS"
248 else
248 else
249 netselect-apt --arch "$RELEASE_ARCH" --tests 10 --sources --outfile "$(pwd)/files/apt/sources.list" -d "$RLS"
249 netselect-apt --arch "$RELEASE_ARCH" --tests 10 --sources --outfile "$(pwd)/files/apt/sources.list" -d "$RLS"
250 fi
250 fi
251
251
252 #sed and cut the result string so we can use it as APT_SERVER
252 #sed and cut the result string so we can use it as APT_SERVER
253 APT_SERVER=$(grep -m 1 http files/apt/sources.list | sed "s|http://| |g" | cut -d ' ' -f 3)
253 APT_SERVER=$(grep -m 1 http files/apt/sources.list | sed "s|http://| |g" | cut -d ' ' -f 3)
254 APT_SERVER=${APT_SERVER::-1}
254 APT_SERVER=${APT_SERVER::-1}
255
255
256 #make script easier and more stable to use with convenient setup switch. Just setup SET_ARCH and RPI_MODEL and your good to go!
256 #make script easier and more stable to use with convenient setup switch. Just setup SET_ARCH and RPI_MODEL and your good to go!
257 if [ -n "$SET_ARCH" ] ; then
257 if [ -n "$SET_ARCH" ] ; then
258 echo "Setting Architecture specific settings"
258 echo "Setting Architecture specific settings"
259 ##################################
259 ##################################
260 # 64 bit config
260 # 64 bit config
261 ##################################
261 ##################################
262 if [ "$SET_ARCH" = 64 ] ; then
262 if [ "$SET_ARCH" = 64 ] ; then
263 echo "64 bit mode selected - Setting up enviroment"
263 echo "64 bit mode selected - Setting up enviroment"
264 # 64 bit depended settings
264 # 64 bit depended settings
265 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-aarch64-static}
265 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-aarch64-static}
266 KERNEL_ARCH=${KERNEL_ARCH:=arm64}
266 KERNEL_ARCH=${KERNEL_ARCH:=arm64}
267 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="Image"}
267 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="Image"}
268
268
269 if [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] ; then
269 if [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] ; then
270 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-arm64"
270 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-arm64"
271 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi3_defconfig}
271 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi3_defconfig}
272 RELEASE_ARCH=${RELEASE_ARCH:=arm64}
272 RELEASE_ARCH=${RELEASE_ARCH:=arm64}
273 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel8.img}
273 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel8.img}
274 CROSS_COMPILE=${CROSS_COMPILE:=aarch64-linux-gnu-}
274 CROSS_COMPILE=${CROSS_COMPILE:=aarch64-linux-gnu-}
275 else
275 else
276 echo "error: Only Raspberry PI 3 and 3B+ support 64bit"
276 echo "error: Only Raspberry PI 3 and 3B+ support 64bit"
277 exit 1
277 exit 1
278 fi
278 fi
279 fi
279 fi
280
280
281 ##################################
281 ##################################
282 # 32 bit config
282 # 32 bit config
283 ##################################
283 ##################################
284 if [ "$SET_ARCH" = 32 ] ; then
284 if [ "$SET_ARCH" = 32 ] ; then
285 echo "32 bit mode selected - Setting up enviroment"
285 echo "32 bit mode selected - Setting up enviroment"
286 #General 32bit configuration
286 #General 32bit configuration
287 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-arm-static}
287 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-arm-static}
288 KERNEL_ARCH=${KERNEL_ARCH:=arm}
288 KERNEL_ARCH=${KERNEL_ARCH:=arm}
289 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="zImage"}
289 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="zImage"}
290
290
291 #Raspberry setting grouped by board compability
291 #Raspberry setting grouped by board compability
292 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 1 ] || [ "$RPI_MODEL" = 1P ] ; then
292 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 1 ] || [ "$RPI_MODEL" = 1P ] ; then
293 echo "Setting settings for bcm2835 Raspberry PI boards"
293 echo "Setting settings for bcm2835 Raspberry PI boards"
294 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armel"
294 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armel"
295 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi_defconfig}
295 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi_defconfig}
296 RELEASE_ARCH=${RELEASE_ARCH:=armel}
296 RELEASE_ARCH=${RELEASE_ARCH:=armel}
297 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel.img}
297 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel.img}
298 CROSS_COMPILE=${CROSS_COMPILE:=arm-linux-gnueabi-}
298 CROSS_COMPILE=${CROSS_COMPILE:=arm-linux-gnueabi-}
299 fi
299 fi
300 if [ "$RPI_MODEL" = 2 ] || [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] ; then
300 if [ "$RPI_MODEL" = 2 ] || [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] ; then
301 echo "Setting settings for bcm2837 Raspberry PI boards"
301 echo "Setting settings for bcm2837 Raspberry PI boards"
302 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armhf"
302 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armhf"
303 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcm2709_defconfig}
303 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcm2709_defconfig}
304 RELEASE_ARCH=${RELEASE_ARCH:=armhf}
304 RELEASE_ARCH=${RELEASE_ARCH:=armhf}
305 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel7.img}
305 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel7.img}
306 CROSS_COMPILE=${CROSS_COMPILE:=arm-linux-gnueabihf-}
306 CROSS_COMPILE=${CROSS_COMPILE:=arm-linux-gnueabihf-}
307 fi
307 fi
308 fi
308 fi
309 #SET_ARCH not set
309 #SET_ARCH not set
310 else
310 else
311 echo "error: Please set '32' or '64' as value for SET_ARCH"
311 echo "error: Please set '32' or '64' as value for SET_ARCH"
312 exit 1
312 exit 1
313 fi
313 fi
314
314
315 #Device specific configuration
315 #Device specific configuration
316 echo "Select DTB-File"
316 echo "Select DTB-File"
317 case "$RPI_MODEL" in
317 case "$RPI_MODEL" in
318 0)
318 0)
319 DTB_FILE=${DTB_FILE:=bcm2708-rpi-0-w.dtb}
319 DTB_FILE=${DTB_FILE:=bcm2708-rpi-0-w.dtb}
320 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
320 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
321 ;;
321 ;;
322 1)
322 1)
323 DTB_FILE=${DTB_FILE:=bcm2708-rpi-b.dtb}
323 DTB_FILE=${DTB_FILE:=bcm2708-rpi-b.dtb}
324 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
324 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
325 ;;
325 ;;
326 1P)
326 1P)
327 DTB_FILE=${DTB_FILE:=bcm2708-rpi-b-plus.dtb}
327 DTB_FILE=${DTB_FILE:=bcm2708-rpi-b-plus.dtb}
328 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
328 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
329 ;;
329 ;;
330 2)
330 2)
331 DTB_FILE=${DTB_FILE:=bcm2709-rpi-2-b.dtb}
331 DTB_FILE=${DTB_FILE:=bcm2709-rpi-2-b.dtb}
332 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_2_defconfig}
332 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_2_defconfig}
333 ;;
333 ;;
334 3)
334 3)
335 DTB_FILE=${DTB_FILE:=bcm2710-rpi-3-b.dtb}
335 DTB_FILE=${DTB_FILE:=bcm2710-rpi-3-b.dtb}
336 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_3_defconfig}
336 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_3_defconfig}
337 ;;
337 ;;
338 3P)
338 3P)
339 DTB_FILE=${DTB_FILE:=bcm2710-rpi-3-b.dtb}
339 DTB_FILE=${DTB_FILE:=bcm2710-rpi-3-b.dtb}
340 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_3_defconfig}
340 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_3_defconfig}
341 ;;
341 ;;
342 *)
342 *)
343 echo "error: Raspberry Pi model $RPI_MODEL is not supported!"
343 echo "error: Raspberry Pi model $RPI_MODEL is not supported!"
344 exit 1
344 exit 1
345 ;;
345 ;;
346 esac
346 esac
347 echo "$DTB_FILE selected"
347 echo "$DTB_FILE selected"
348
348
349 #DEBUG off
349 #DEBUG off
350 set +x
350 set +x
351
351
352 # Check if the internal wireless interface is supported by the RPi model
352 # Check if the internal wireless interface is supported by the RPi model
353 if [ "$ENABLE_WIRELESS" = true ] ; then
353 if [ "$ENABLE_WIRELESS" = true ] ; then
354 if [ "$RPI_MODEL" = 1 ] || [ "$RPI_MODEL" = 1P ] || [ "$RPI_MODEL" = 2 ] ; then
354 if [ "$RPI_MODEL" = 1 ] || [ "$RPI_MODEL" = 1P ] || [ "$RPI_MODEL" = 2 ] ; then
355 echo "error: The selected Raspberry Pi model has no internal wireless interface"
355 echo "error: The selected Raspberry Pi model has no internal wireless interface"
356 exit 1
356 exit 1
357 else
357 else
358 echo "Raspberry Pi $RPI_MODEL has WIFI support"
358 echo "Raspberry Pi $RPI_MODEL has WIFI support"
359 fi
359 fi
360 fi
360 fi
361
361
362 # Check if DISABLE_UNDERVOLT_WARNINGS parameter value is supported
362 # Check if DISABLE_UNDERVOLT_WARNINGS parameter value is supported
363 if [ -n "$DISABLE_UNDERVOLT_WARNINGS" ] ; then
363 if [ -n "$DISABLE_UNDERVOLT_WARNINGS" ] ; then
364 if [ "$DISABLE_UNDERVOLT_WARNINGS" != 1 ] && [ "$DISABLE_UNDERVOLT_WARNINGS" != 2 ] ; then
364 if [ "$DISABLE_UNDERVOLT_WARNINGS" != 1 ] && [ "$DISABLE_UNDERVOLT_WARNINGS" != 2 ] ; then
365 echo "error: DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS} is not supported"
365 echo "error: DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS} is not supported"
366 exit 1
366 exit 1
367 fi
367 fi
368 fi
368 fi
369
369
370 if [ "$ENABLE_VIDEOCORE" = true ] ; then
370 if [ "$ENABLE_VIDEOCORE" = true ] ; then
371 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} cmake"
371 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} cmake"
372 fi
372 fi
373
373
374 # Add libncurses5 to enable kernel menuconfig
374 # Add libncurses5 to enable kernel menuconfig
375 if [ "$KERNEL_MENUCONFIG" = true ] ; then
375 if [ "$KERNEL_MENUCONFIG" = true ] ; then
376 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} libncurses-dev"
376 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} libncurses-dev"
377 fi
377 fi
378
378
379 # Add ccache compiler cache for (faster) kernel cross (re)compilation
379 # Add ccache compiler cache for (faster) kernel cross (re)compilation
380 if [ "$KERNEL_CCACHE" = true ] ; then
380 if [ "$KERNEL_CCACHE" = true ] ; then
381 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} ccache"
381 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} ccache"
382 fi
382 fi
383
383
384 # Add cryptsetup package to enable filesystem encryption
384 # Add cryptsetup package to enable filesystem encryption
385 if [ "$ENABLE_CRYPTFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
385 if [ "$ENABLE_CRYPTFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
386 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} cryptsetup"
386 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} cryptsetup"
387 APT_INCLUDES="${APT_INCLUDES},cryptsetup,busybox,console-setup"
387 APT_INCLUDES="${APT_INCLUDES},cryptsetup,busybox,console-setup"
388
388
389 if [ -z "$CRYPTFS_PASSWORD" ] ; then
389 if [ -z "$CRYPTFS_PASSWORD" ] ; then
390 echo "error: no password defined (CRYPTFS_PASSWORD)!"
390 echo "error: no password defined (CRYPTFS_PASSWORD)!"
391 exit 1
391 exit 1
392 fi
392 fi
393 ENABLE_INITRAMFS=true
393 ENABLE_INITRAMFS=true
394 fi
394 fi
395
395
396 # Add initramfs generation tools
396 # Add initramfs generation tools
397 if [ "$ENABLE_INITRAMFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
397 if [ "$ENABLE_INITRAMFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
398 APT_INCLUDES="${APT_INCLUDES},initramfs-tools"
398 APT_INCLUDES="${APT_INCLUDES},initramfs-tools"
399 fi
399 fi
400
400
401 # Add device-tree-compiler required for building the U-Boot bootloader
401 # Add device-tree-compiler required for building the U-Boot bootloader
402 if [ "$ENABLE_UBOOT" = true ] ; then
402 if [ "$ENABLE_UBOOT" = true ] ; then
403 APT_INCLUDES="${APT_INCLUDES},device-tree-compiler,bison,flex,bc"
403 APT_INCLUDES="${APT_INCLUDES},device-tree-compiler,bison,flex,bc"
404 else
404 else
405 if [ "$ENABLE_UBOOTUSB" = true ] ; then
405 if [ "$ENABLE_UBOOTUSB" = true ] ; then
406 echo "error: Enabling UBOOTUSB requires u-boot to be enabled"
406 echo "error: Enabling UBOOTUSB requires u-boot to be enabled"
407 exit 1
407 exit 1
408 fi
408 fi
409 fi
409 fi
410
410
411 # Check if root SSH (v2) public key file exists
411 # Check if root SSH (v2) public key file exists
412 if [ -n "$SSH_ROOT_PUB_KEY" ] ; then
412 if [ -n "$SSH_ROOT_PUB_KEY" ] ; then
413 if [ ! -f "$SSH_ROOT_PUB_KEY" ] ; then
413 if [ ! -f "$SSH_ROOT_PUB_KEY" ] ; then
414 echo "error: '$SSH_ROOT_PUB_KEY' specified SSH public key file not found (SSH_ROOT_PUB_KEY)!"
414 echo "error: '$SSH_ROOT_PUB_KEY' specified SSH public key file not found (SSH_ROOT_PUB_KEY)!"
415 exit 1
415 exit 1
416 fi
416 fi
417 fi
417 fi
418
418
419 # Check if $USER_NAME SSH (v2) public key file exists
419 # Check if $USER_NAME SSH (v2) public key file exists
420 if [ -n "$SSH_USER_PUB_KEY" ] ; then
420 if [ -n "$SSH_USER_PUB_KEY" ] ; then
421 if [ ! -f "$SSH_USER_PUB_KEY" ] ; then
421 if [ ! -f "$SSH_USER_PUB_KEY" ] ; then
422 echo "error: '$SSH_USER_PUB_KEY' specified SSH public key file not found (SSH_USER_PUB_KEY)!"
422 echo "error: '$SSH_USER_PUB_KEY' specified SSH public key file not found (SSH_USER_PUB_KEY)!"
423 exit 1
423 exit 1
424 fi
424 fi
425 fi
425 fi
426
426
427 # Check if all required packages are installed on the build system
427 # Check if all required packages are installed on the build system
428 for package in $REQUIRED_PACKAGES ; do
428 for package in $REQUIRED_PACKAGES ; do
429 if [ "$(dpkg-query -W -f='${Status}' $package)" != "install ok installed" ] ; then
429 if [ "$(dpkg-query -W -f='${Status}' $package)" != "install ok installed" ] ; then
430 MISSING_PACKAGES="${MISSING_PACKAGES} $package"
430 MISSING_PACKAGES="${MISSING_PACKAGES} $package"
431 fi
431 fi
432 done
432 done
433
433
434 # If there are missing packages ask confirmation for install, or exit
434 # If there are missing packages ask confirmation for install, or exit
435 if [ -n "$MISSING_PACKAGES" ] ; then
435 if [ -n "$MISSING_PACKAGES" ] ; then
436 echo "the following packages needed by this script are not installed:"
436 echo "the following packages needed by this script are not installed:"
437 echo "$MISSING_PACKAGES"
437 echo "$MISSING_PACKAGES"
438
438
439 printf "\ndo you want to install the missing packages right now? [y/n] "
439 printf "\ndo you want to install the missing packages right now? [y/n] "
440 read -r confirm
440 read -r confirm
441 [ "$confirm" != "y" ] && exit 1
441 [ "$confirm" != "y" ] && exit 1
442
442
443 # Make sure all missing required packages are installed
443 # Make sure all missing required packages are installed
444 apt-get -qq -y install "${MISSING_PACKAGES}"
444 apt-get -qq -y install "${MISSING_PACKAGES}"
445 fi
445 fi
446
446
447 # Check if ./bootstrap.d directory exists
447 # Check if ./bootstrap.d directory exists
448 if [ ! -d "./bootstrap.d/" ] ; then
448 if [ ! -d "./bootstrap.d/" ] ; then
449 echo "error: './bootstrap.d' required directory not found!"
449 echo "error: './bootstrap.d' required directory not found!"
450 exit 1
450 exit 1
451 fi
451 fi
452
452
453 # Check if ./files directory exists
453 # Check if ./files directory exists
454 if [ ! -d "./files/" ] ; then
454 if [ ! -d "./files/" ] ; then
455 echo "error: './files' required directory not found!"
455 echo "error: './files' required directory not found!"
456 exit 1
456 exit 1
457 fi
457 fi
458
458
459 # Check if specified KERNELSRC_DIR directory exists
459 # Check if specified KERNELSRC_DIR directory exists
460 if [ -n "$KERNELSRC_DIR" ] && [ ! -d "$KERNELSRC_DIR" ] ; then
460 if [ -n "$KERNELSRC_DIR" ] && [ ! -d "$KERNELSRC_DIR" ] ; then
461 echo "error: '${KERNELSRC_DIR}' specified directory not found (KERNELSRC_DIR)!"
461 echo "error: '${KERNELSRC_DIR}' specified directory not found (KERNELSRC_DIR)!"
462 exit 1
462 exit 1
463 fi
463 fi
464
464
465 # Check if specified UBOOTSRC_DIR directory exists
465 # Check if specified UBOOTSRC_DIR directory exists
466 if [ -n "$UBOOTSRC_DIR" ] && [ ! -d "$UBOOTSRC_DIR" ] ; then
466 if [ -n "$UBOOTSRC_DIR" ] && [ ! -d "$UBOOTSRC_DIR" ] ; then
467 echo "error: '${UBOOTSRC_DIR}' specified directory not found (UBOOTSRC_DIR)!"
467 echo "error: '${UBOOTSRC_DIR}' specified directory not found (UBOOTSRC_DIR)!"
468 exit 1
468 exit 1
469 fi
469 fi
470
470
471 # Check if specified VIDEOCORESRC_DIR directory exists
471 # Check if specified VIDEOCORESRC_DIR directory exists
472 if [ -n "$VIDEOCORESRC_DIR" ] && [ ! -d "$VIDEOCORESRC_DIR" ] ; then
472 if [ -n "$VIDEOCORESRC_DIR" ] && [ ! -d "$VIDEOCORESRC_DIR" ] ; then
473 echo "error: '${VIDEOCORESRC_DIR}' specified directory not found (VIDEOCORESRC_DIR)!"
473 echo "error: '${VIDEOCORESRC_DIR}' specified directory not found (VIDEOCORESRC_DIR)!"
474 exit 1
474 exit 1
475 fi
475 fi
476
476
477 # Check if specified FBTURBOSRC_DIR directory exists
477 # Check if specified FBTURBOSRC_DIR directory exists
478 if [ -n "$FBTURBOSRC_DIR" ] && [ ! -d "$FBTURBOSRC_DIR" ] ; then
478 if [ -n "$FBTURBOSRC_DIR" ] && [ ! -d "$FBTURBOSRC_DIR" ] ; then
479 echo "error: '${FBTURBOSRC_DIR}' specified directory not found (FBTURBOSRC_DIR)!"
479 echo "error: '${FBTURBOSRC_DIR}' specified directory not found (FBTURBOSRC_DIR)!"
480 exit 1
480 exit 1
481 fi
481 fi
482
482
483 # Check if specified CHROOT_SCRIPTS directory exists
483 # Check if specified CHROOT_SCRIPTS directory exists
484 if [ -n "$CHROOT_SCRIPTS" ] && [ ! -d "$CHROOT_SCRIPTS" ] ; then
484 if [ -n "$CHROOT_SCRIPTS" ] && [ ! -d "$CHROOT_SCRIPTS" ] ; then
485 echo "error: ${CHROOT_SCRIPTS} specified directory not found (CHROOT_SCRIPTS)!"
485 echo "error: ${CHROOT_SCRIPTS} specified directory not found (CHROOT_SCRIPTS)!"
486 exit 1
486 exit 1
487 fi
487 fi
488
488
489 # Check if specified device mapping already exists (will be used by cryptsetup)
489 # Check if specified device mapping already exists (will be used by cryptsetup)
490 if [ -r "/dev/mapping/${CRYPTFS_MAPPING}" ] ; then
490 if [ -r "/dev/mapping/${CRYPTFS_MAPPING}" ] ; then
491 echo "error: mapping /dev/mapping/${CRYPTFS_MAPPING} already exists, not proceeding"
491 echo "error: mapping /dev/mapping/${CRYPTFS_MAPPING} already exists, not proceeding"
492 exit 1
492 exit 1
493 fi
493 fi
494
494
495 # Don't clobber an old build
495 # Don't clobber an old build
496 if [ -e "$BUILDDIR" ] ; then
496 if [ -e "$BUILDDIR" ] ; then
497 echo "error: directory ${BUILDDIR} already exists, not proceeding"
497 echo "error: directory ${BUILDDIR} already exists, not proceeding"
498 exit 1
498 exit 1
499 fi
499 fi
500
500
501 # Setup chroot directory
501 # Setup chroot directory
502 mkdir -p "${R}"
502 mkdir -p "${R}"
503
503
504 # Check if build directory has enough of free disk space >512MB
504 # Check if build directory has enough of free disk space >512MB
505 if [ "$(df --output=avail "${BUILDDIR}" | sed "1d")" -le "524288" ] ; then
505 if [ "$(df --output=avail "${BUILDDIR}" | sed "1d")" -le "524288" ] ; then
506 echo "error: ${BUILDDIR} not enough space left to generate the output image!"
506 echo "error: ${BUILDDIR} not enough space left to generate the output image!"
507 exit 1
507 exit 1
508 fi
508 fi
509
509
510 set -x
510 set -x
511
511
512 # Call "cleanup" function on various signals and errors
512 # Call "cleanup" function on various signals and errors
513 trap cleanup 0 1 2 3 6
513 trap cleanup 0 1 2 3 6
514
514
515 # Add required packages for the minbase installation
515 # Add required packages for the minbase installation
516 if [ "$ENABLE_MINBASE" = true ] ; then
516 if [ "$ENABLE_MINBASE" = true ] ; then
517 APT_INCLUDES="${APT_INCLUDES},vim-tiny,netbase,net-tools,ifupdown"
517 APT_INCLUDES="${APT_INCLUDES},vim-tiny,netbase,net-tools,ifupdown"
518 fi
518 fi
519
519
520 # Add parted package, required to get partprobe utility
520 # Add parted package, required to get partprobe utility
521 if [ "$EXPANDROOT" = true ] ; then
521 if [ "$EXPANDROOT" = true ] ; then
522 APT_INCLUDES="${APT_INCLUDES},parted"
522 APT_INCLUDES="${APT_INCLUDES},parted"
523 fi
523 fi
524
524
525 # Add dbus package, recommended if using systemd
525 # Add dbus package, recommended if using systemd
526 if [ "$ENABLE_DBUS" = true ] ; then
526 if [ "$ENABLE_DBUS" = true ] ; then
527 APT_INCLUDES="${APT_INCLUDES},dbus"
527 APT_INCLUDES="${APT_INCLUDES},dbus"
528 fi
528 fi
529
529
530 # Add iptables IPv4/IPv6 package
530 # Add iptables IPv4/IPv6 package
531 if [ "$ENABLE_IPTABLES" = true ] ; then
531 if [ "$ENABLE_IPTABLES" = true ] ; then
532 APT_INCLUDES="${APT_INCLUDES},iptables,iptables-persistent"
532 APT_INCLUDES="${APT_INCLUDES},iptables,iptables-persistent"
533 fi
533 fi
534
534
535 # Add openssh server package
535 # Add openssh server package
536 if [ "$ENABLE_SSHD" = true ] ; then
536 if [ "$ENABLE_SSHD" = true ] ; then
537 APT_INCLUDES="${APT_INCLUDES},openssh-server"
537 APT_INCLUDES="${APT_INCLUDES},openssh-server"
538 fi
538 fi
539
539
540 # Add alsa-utils package
540 # Add alsa-utils package
541 if [ "$ENABLE_SOUND" = true ] ; then
541 if [ "$ENABLE_SOUND" = true ] ; then
542 APT_INCLUDES="${APT_INCLUDES},alsa-utils"
542 APT_INCLUDES="${APT_INCLUDES},alsa-utils"
543 fi
543 fi
544
544
545 # Add rng-tools package
545 # Add rng-tools package
546 if [ "$ENABLE_HWRANDOM" = true ] ; then
546 if [ "$ENABLE_HWRANDOM" = true ] ; then
547 APT_INCLUDES="${APT_INCLUDES},rng-tools"
547 APT_INCLUDES="${APT_INCLUDES},rng-tools"
548 fi
548 fi
549
549
550 # Add fbturbo video driver
550 # Add fbturbo video driver
551 if [ "$ENABLE_FBTURBO" = true ] ; then
551 if [ "$ENABLE_FBTURBO" = true ] ; then
552 # Enable xorg package dependencies
552 # Enable xorg package dependencies
553 ENABLE_XORG=true
553 ENABLE_XORG=true
554 fi
554 fi
555
555
556 # Add user defined window manager package
556 # Add user defined window manager package
557 if [ -n "$ENABLE_WM" ] ; then
557 if [ -n "$ENABLE_WM" ] ; then
558 APT_INCLUDES="${APT_INCLUDES},${ENABLE_WM}"
558 APT_INCLUDES="${APT_INCLUDES},${ENABLE_WM}"
559
559
560 # Enable xorg package dependencies
560 # Enable xorg package dependencies
561 ENABLE_XORG=true
561 ENABLE_XORG=true
562 fi
562 fi
563
563
564 # Add xorg package
564 # Add xorg package
565 if [ "$ENABLE_XORG" = true ] ; then
565 if [ "$ENABLE_XORG" = true ] ; then
566 APT_INCLUDES="${APT_INCLUDES},xorg,dbus-x11"
566 APT_INCLUDES="${APT_INCLUDES},xorg,dbus-x11"
567 fi
567 fi
568
568
569 # Replace selected packages with smaller clones
569 # Replace selected packages with smaller clones
570 if [ "$ENABLE_REDUCE" = true ] ; then
570 if [ "$ENABLE_REDUCE" = true ] ; then
571 # Add levee package instead of vim-tiny
571 # Add levee package instead of vim-tiny
572 if [ "$REDUCE_VIM" = true ] ; then
572 if [ "$REDUCE_VIM" = true ] ; then
573 APT_INCLUDES="$(echo ${APT_INCLUDES} | sed "s/vim-tiny/levee/")"
573 APT_INCLUDES="$(echo ${APT_INCLUDES} | sed "s/vim-tiny/levee/")"
574 fi
574 fi
575
575
576 # Add dropbear package instead of openssh-server
576 # Add dropbear package instead of openssh-server
577 if [ "$REDUCE_SSHD" = true ] ; then
577 if [ "$REDUCE_SSHD" = true ] ; then
578 APT_INCLUDES="$(echo "${APT_INCLUDES}" | sed "s/openssh-server/dropbear/")"
578 APT_INCLUDES="$(echo "${APT_INCLUDES}" | sed "s/openssh-server/dropbear/")"
579 fi
579 fi
580 fi
580 fi
581
581
582 # Configure kernel sources if no KERNELSRC_DIR
582 # Configure kernel sources if no KERNELSRC_DIR
583 if [ "$BUILD_KERNEL" = true ] && [ -z "$KERNELSRC_DIR" ] ; then
583 if [ "$BUILD_KERNEL" = true ] && [ -z "$KERNELSRC_DIR" ] ; then
584 KERNELSRC_CONFIG=true
584 KERNELSRC_CONFIG=true
585 fi
585 fi
586
586
587 # Configure reduced kernel
587 # Configure reduced kernel
588 if [ "$KERNEL_REDUCE" = true ] ; then
588 if [ "$KERNEL_REDUCE" = true ] ; then
589 KERNELSRC_CONFIG=false
589 KERNELSRC_CONFIG=false
590 fi
590 fi
591
591
592 # Configure qemu compatible kernel
592 # Configure qemu compatible kernel
593 if [ "$ENABLE_QEMU" = true ] ; then
593 if [ "$ENABLE_QEMU" = true ] ; then
594 DTB_FILE=vexpress-v2p-ca15_a7.dtb
594 DTB_FILE=vexpress-v2p-ca15_a7.dtb
595 UBOOT_CONFIG=vexpress_ca15_tc2_defconfig
595 UBOOT_CONFIG=vexpress_ca15_tc2_defconfig
596 KERNEL_DEFCONFIG="vexpress_defconfig"
596 KERNEL_DEFCONFIG="vexpress_defconfig"
597 if [ "$KERNEL_MENUCONFIG" = false ] ; then
597 if [ "$KERNEL_MENUCONFIG" = false ] ; then
598 KERNEL_OLDDEFCONFIG=true
598 KERNEL_OLDDEFCONFIG=true
599 fi
599 fi
600 fi
600 fi
601
601
602 # Execute bootstrap scripts
602 # Execute bootstrap scripts
603 for SCRIPT in bootstrap.d/*.sh; do
603 for SCRIPT in bootstrap.d/*.sh; do
604 head -n 3 "$SCRIPT"
604 head -n 3 "$SCRIPT"
605 . "$SCRIPT"
605 . "$SCRIPT"
606 done
606 done
607
607
608 ## Execute custom bootstrap scripts
608 ## Execute custom bootstrap scripts
609 if [ -d "custom.d" ] ; then
609 if [ -d "custom.d" ] ; then
610 for SCRIPT in custom.d/*.sh; do
610 for SCRIPT in custom.d/*.sh; do
611 . "$SCRIPT"
611 . "$SCRIPT"
612 done
612 done
613 fi
613 fi
614
614
615 # Execute custom scripts inside the chroot
615 # Execute custom scripts inside the chroot
616 if [ -n "$CHROOT_SCRIPTS" ] && [ -d "$CHROOT_SCRIPTS" ] ; then
616 if [ -n "$CHROOT_SCRIPTS" ] && [ -d "$CHROOT_SCRIPTS" ] ; then
617 cp -r "${CHROOT_SCRIPTS}" "${R}/chroot_scripts"
617 cp -r "${CHROOT_SCRIPTS}" "${R}/chroot_scripts"
618 chroot_exec /bin/bash -x <<'EOF'
618 chroot_exec /bin/bash -x <<'EOF'
619 for SCRIPT in /chroot_scripts/* ; do
619 for SCRIPT in /chroot_scripts/* ; do
620 if [ -f $SCRIPT -a -x $SCRIPT ] ; then
620 if [ -f $SCRIPT -a -x $SCRIPT ] ; then
621 $SCRIPT
621 $SCRIPT
622 fi
622 fi
623 done
623 done
624 EOF
624 EOF
625 rm -rf "${R}/chroot_scripts"
625 rm -rf "${R}/chroot_scripts"
626 fi
626 fi
627
627
628 # Remove c/c++ build environment from the chroot
628 # Remove c/c++ build environment from the chroot
629 chroot_remove_cc
629 chroot_remove_cc
630
630
631 # Generate required machine-id
631 # Generate required machine-id
632 MACHINE_ID=$(dbus-uuidgen)
632 MACHINE_ID=$(dbus-uuidgen)
633 echo -n "${MACHINE_ID}" > "${R}/var/lib/dbus/machine-id"
633 echo -n "${MACHINE_ID}" > "${R}/var/lib/dbus/machine-id"
634 echo -n "${MACHINE_ID}" > "${ETC_DIR}/machine-id"
634 echo -n "${MACHINE_ID}" > "${ETC_DIR}/machine-id"
635
635
636 # APT Cleanup
636 # APT Cleanup
637 chroot_exec apt-get -y clean
637 chroot_exec apt-get -y clean
638 chroot_exec apt-get -y autoclean
638 chroot_exec apt-get -y autoclean
639 chroot_exec apt-get -y autoremove
639 chroot_exec apt-get -y autoremove
640
640
641 # Unmount mounted filesystems
641 # Unmount mounted filesystems
642 umount -l "${R}/proc"
642 umount -l "${R}/proc"
643 umount -l "${R}/sys"
643 umount -l "${R}/sys"
644
644
645 # Clean up directories
645 # Clean up directories
646 rm -rf "${R}/run/*"
646 rm -rf "${R}/run/*"
647 rm -rf "${R}/tmp/*"
647 rm -rf "${R}/tmp/*"
648
648
649 # Clean up files
649 # Clean up files
650 rm -f "${ETC_DIR}/ssh/ssh_host_*"
650 rm -f "${ETC_DIR}/ssh/ssh_host_*"
651 rm -f "${ETC_DIR}/dropbear/dropbear_*"
651 rm -f "${ETC_DIR}/dropbear/dropbear_*"
652 rm -f "${ETC_DIR}/apt/sources.list.save"
652 rm -f "${ETC_DIR}/apt/sources.list.save"
653 rm -f "${ETC_DIR}/resolvconf/resolv.conf.d/original"
653 rm -f "${ETC_DIR}/resolvconf/resolv.conf.d/original"
654 rm -f "${ETC_DIR}/*-"
654 rm -f "${ETC_DIR}/*-"
655 rm -f "${ETC_DIR}/apt/apt.conf.d/10proxy"
655 rm -f "${ETC_DIR}/apt/apt.conf.d/10proxy"
656 rm -f "${ETC_DIR}/resolv.conf"
656 rm -f "${ETC_DIR}/resolv.conf"
657 rm -f "${R}/root/.bash_history"
657 rm -f "${R}/root/.bash_history"
658 rm -f "${R}/var/lib/urandom/random-seed"
658 rm -f "${R}/var/lib/urandom/random-seed"
659 rm -f "${R}/initrd.img"
659 rm -f "${R}/initrd.img"
660 rm -f "${R}/vmlinuz"
660 rm -f "${R}/vmlinuz"
661 rm -f "${R}${QEMU_BINARY}"
661 rm -f "${R}${QEMU_BINARY}"
662
662
663 if [ "$ENABLE_QEMU" = true ] ; then
663 if [ "$ENABLE_QEMU" = true ] ; then
664 # Setup QEMU directory
664 # Setup QEMU directory
665 mkdir "${BASEDIR}/qemu"
665 mkdir "${BASEDIR}/qemu"
666
666
667 # Copy kernel image to QEMU directory
667 # Copy kernel image to QEMU directory
668 install_readonly "${BOOT_DIR}/${KERNEL_IMAGE}" "${BASEDIR}/qemu/${KERNEL_IMAGE}"
668 install_readonly "${BOOT_DIR}/${KERNEL_IMAGE}" "${BASEDIR}/qemu/${KERNEL_IMAGE}"
669
669
670 # Copy kernel config to QEMU directory
670 # Copy kernel config to QEMU directory
671 install_readonly "${R}/boot/config-${KERNEL_VERSION}" "${BASEDIR}/qemu/config-${KERNEL_VERSION}"
671 install_readonly "${R}/boot/config-${KERNEL_VERSION}" "${BASEDIR}/qemu/config-${KERNEL_VERSION}"
672
672
673 # Copy kernel dtbs to QEMU directory
673 # Copy kernel dtbs to QEMU directory
674 for dtb in "${BOOT_DIR}/"*.dtb ; do
674 for dtb in "${BOOT_DIR}/"*.dtb ; do
675 if [ -f "${dtb}" ] ; then
675 if [ -f "${dtb}" ] ; then
676 install_readonly "${dtb}" "${BASEDIR}/qemu/"
676 install_readonly "${dtb}" "${BASEDIR}/qemu/"
677 fi
677 fi
678 done
678 done
679
679
680 # Copy kernel overlays to QEMU directory
680 # Copy kernel overlays to QEMU directory
681 if [ -d "${BOOT_DIR}/overlays" ] ; then
681 if [ -d "${BOOT_DIR}/overlays" ] ; then
682 # Setup overlays dtbs directory
682 # Setup overlays dtbs directory
683 mkdir "${BASEDIR}/qemu/overlays"
683 mkdir "${BASEDIR}/qemu/overlays"
684
684
685 for dtb in "${BOOT_DIR}/overlays/"*.dtb ; do
685 for dtb in "${BOOT_DIR}/overlays/"*.dtb ; do
686 if [ -f "${dtb}" ] ; then
686 if [ -f "${dtb}" ] ; then
687 install_readonly "${dtb}" "${BASEDIR}/qemu/overlays/"
687 install_readonly "${dtb}" "${BASEDIR}/qemu/overlays/"
688 fi
688 fi
689 done
689 done
690 fi
690 fi
691
691
692 # Copy u-boot files to QEMU directory
692 # Copy u-boot files to QEMU directory
693 if [ "$ENABLE_UBOOT" = true ] ; then
693 if [ "$ENABLE_UBOOT" = true ] ; then
694 if [ -f "${BOOT_DIR}/u-boot.bin" ] ; then
694 if [ -f "${BOOT_DIR}/u-boot.bin" ] ; then
695 install_readonly "${BOOT_DIR}/u-boot.bin" "${BASEDIR}/qemu/u-boot.bin"
695 install_readonly "${BOOT_DIR}/u-boot.bin" "${BASEDIR}/qemu/u-boot.bin"
696 fi
696 fi
697 if [ -f "${BOOT_DIR}/uboot.mkimage" ] ; then
697 if [ -f "${BOOT_DIR}/uboot.mkimage" ] ; then
698 install_readonly "${BOOT_DIR}/uboot.mkimage" "${BASEDIR}/qemu/uboot.mkimage"
698 install_readonly "${BOOT_DIR}/uboot.mkimage" "${BASEDIR}/qemu/uboot.mkimage"
699 fi
699 fi
700 if [ -f "${BOOT_DIR}/boot.scr" ] ; then
700 if [ -f "${BOOT_DIR}/boot.scr" ] ; then
701 install_readonly "${BOOT_DIR}/boot.scr" "${BASEDIR}/qemu/boot.scr"
701 install_readonly "${BOOT_DIR}/boot.scr" "${BASEDIR}/qemu/boot.scr"
702 fi
702 fi
703 fi
703 fi
704
704
705 # Copy initramfs to QEMU directory
705 # Copy initramfs to QEMU directory
706 if [ -f "${BOOT_DIR}/initramfs-${KERNEL_VERSION}" ] ; then
706 if [ -f "${BOOT_DIR}/initramfs-${KERNEL_VERSION}" ] ; then
707 install_readonly "${BOOT_DIR}/initramfs-${KERNEL_VERSION}" "${BASEDIR}/qemu/initramfs-${KERNEL_VERSION}"
707 install_readonly "${BOOT_DIR}/initramfs-${KERNEL_VERSION}" "${BASEDIR}/qemu/initramfs-${KERNEL_VERSION}"
708 fi
708 fi
709 fi
709 fi
710
710
711 # Calculate size of the chroot directory in KB
711 # Calculate size of the chroot directory in KB
712 CHROOT_SIZE=$(expr "$(du -s "${R}" | awk '{ print $1 }')")
712 CHROOT_SIZE=$(expr "$(du -s "${R}" | awk '{ print $1 }')")
713
713
714 # Calculate the amount of needed 512 Byte sectors
714 # Calculate the amount of needed 512 Byte sectors
715 TABLE_SECTORS=$(expr 1 \* 1024 \* 1024 \/ 512)
715 TABLE_SECTORS=$(expr 1 \* 1024 \* 1024 \/ 512)
716 FRMW_SECTORS=$(expr 64 \* 1024 \* 1024 \/ 512)
716 FRMW_SECTORS=$(expr 64 \* 1024 \* 1024 \/ 512)
717 ROOT_OFFSET=$(expr "${TABLE_SECTORS}" + "${FRMW_SECTORS}")
717 ROOT_OFFSET=$(expr "${TABLE_SECTORS}" + "${FRMW_SECTORS}")
718
718
719 # The root partition is EXT4
719 # The root partition is EXT4
720 # This means more space than the actual used space of the chroot is used.
720 # This means more space than the actual used space of the chroot is used.
721 # As overhead for journaling and reserved blocks 35% are added.
721 # As overhead for journaling and reserved blocks 35% are added.
722 ROOT_SECTORS=$(expr "$(expr "${CHROOT_SIZE}" + "${CHROOT_SIZE}" \/ 100 \* 35)" \* 1024 \/ 512)
722 ROOT_SECTORS=$(expr "$(expr "${CHROOT_SIZE}" + "${CHROOT_SIZE}" \/ 100 \* 35)" \* 1024 \/ 512)
723
723
724 # Calculate required image size in 512 Byte sectors
724 # Calculate required image size in 512 Byte sectors
725 IMAGE_SECTORS=$(expr "${TABLE_SECTORS}" + "${FRMW_SECTORS}" + "${ROOT_SECTORS}")
725 IMAGE_SECTORS=$(expr "${TABLE_SECTORS}" + "${FRMW_SECTORS}" + "${ROOT_SECTORS}")
726
726
727 # Prepare image file
727 # Prepare image file
728 if [ "$ENABLE_SPLITFS" = true ] ; then
728 if [ "$ENABLE_SPLITFS" = true ] ; then
729 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count="${TABLE_SECTORS}"
729 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count="${TABLE_SECTORS}"
730 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count=0 seek="${FRMW_SECTORS}"
730 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count=0 seek="${FRMW_SECTORS}"
731 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count="${TABLE_SECTORS}"
731 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count="${TABLE_SECTORS}"
732 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count=0 seek="${ROOT_SECTORS}"
732 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count=0 seek="${ROOT_SECTORS}"
733
733
734 # Write firmware/boot partition tables
734 # Write firmware/boot partition tables
735 sfdisk -q -L -uS -f "$IMAGE_NAME-frmw.img" 2> /dev/null <<EOM
735 sfdisk -q -L -uS -f "$IMAGE_NAME-frmw.img" 2> /dev/null <<EOM
736 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
736 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
737 EOM
737 EOM
738
738
739 # Write root partition table
739 # Write root partition table
740 sfdisk -q -L -uS -f "$IMAGE_NAME-root.img" 2> /dev/null <<EOM
740 sfdisk -q -L -uS -f "$IMAGE_NAME-root.img" 2> /dev/null <<EOM
741 ${TABLE_SECTORS},${ROOT_SECTORS},83
741 ${TABLE_SECTORS},${ROOT_SECTORS},83
742 EOM
742 EOM
743
743
744 # Setup temporary loop devices
744 # Setup temporary loop devices
745 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show "$IMAGE_NAME"-frmw.img)"
745 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show "$IMAGE_NAME"-frmw.img)"
746 ROOT_LOOP="$(losetup -o 1M -f --show "$IMAGE_NAME"-root.img)"
746 ROOT_LOOP="$(losetup -o 1M -f --show "$IMAGE_NAME"-root.img)"
747 else # ENABLE_SPLITFS=false
747 else # ENABLE_SPLITFS=false
748 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count="${TABLE_SECTORS}"
748 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count="${TABLE_SECTORS}"
749 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count=0 seek="${IMAGE_SECTORS}"
749 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count=0 seek="${IMAGE_SECTORS}"
750
750
751 # Write partition table
751 # Write partition table
752 sfdisk -q -L -uS -f "$IMAGE_NAME.img" 2> /dev/null <<EOM
752 sfdisk -q -L -uS -f "$IMAGE_NAME.img" 2> /dev/null <<EOM
753 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
753 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
754 ${ROOT_OFFSET},${ROOT_SECTORS},83
754 ${ROOT_OFFSET},${ROOT_SECTORS},83
755 EOM
755 EOM
756
756
757 # Setup temporary loop devices
757 # Setup temporary loop devices
758 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show "$IMAGE_NAME".img)"
758 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show "$IMAGE_NAME".img)"
759 ROOT_LOOP="$(losetup -o 65M -f --show "$IMAGE_NAME".img)"
759 ROOT_LOOP="$(losetup -o 65M -f --show "$IMAGE_NAME".img)"
760 fi
760 fi
761
761
762 if [ "$ENABLE_CRYPTFS" = true ] ; then
762 if [ "$ENABLE_CRYPTFS" = true ] ; then
763 # Create dummy ext4 fs
763 # Create dummy ext4 fs
764 mkfs.ext4 "$ROOT_LOOP"
764 mkfs.ext4 "$ROOT_LOOP"
765
765
766 # Setup password keyfile
766 # Setup password keyfile
767 touch .password
767 touch .password
768 chmod 600 .password
768 chmod 600 .password
769 echo -n ${CRYPTFS_PASSWORD} > .password
769 echo -n ${CRYPTFS_PASSWORD} > .password
770
770
771 # Initialize encrypted partition
771 # Initialize encrypted partition
772 echo "YES" | cryptsetup luksFormat "${ROOT_LOOP}" -c "${CRYPTFS_CIPHER}" -s "${CRYPTFS_XTSKEYSIZE}" .password
772 echo "YES" | cryptsetup luksFormat "${ROOT_LOOP}" -c "${CRYPTFS_CIPHER}" -s "${CRYPTFS_XTSKEYSIZE}" .password
773
773
774 # Open encrypted partition and setup mapping
774 # Open encrypted partition and setup mapping
775 cryptsetup luksOpen "${ROOT_LOOP}" -d .password "${CRYPTFS_MAPPING}"
775 cryptsetup luksOpen "${ROOT_LOOP}" -d .password "${CRYPTFS_MAPPING}"
776
776
777 # Secure delete password keyfile
777 # Secure delete password keyfile
778 shred -zu .password
778 shred -zu .password
779
779
780 # Update temporary loop device
780 # Update temporary loop device
781 ROOT_LOOP="/dev/mapper/${CRYPTFS_MAPPING}"
781 ROOT_LOOP="/dev/mapper/${CRYPTFS_MAPPING}"
782
782
783 # Wipe encrypted partition (encryption cipher is used for randomness)
783 # Wipe encrypted partition (encryption cipher is used for randomness)
784 dd if=/dev/zero of="${ROOT_LOOP}" bs=512 count="$(blockdev --getsz "${ROOT_LOOP}")"
784 dd if=/dev/zero of="${ROOT_LOOP}" bs=512 count="$(blockdev --getsz "${ROOT_LOOP}")"
785 fi
785 fi
786
786
787 # Build filesystems
787 # Build filesystems
788 mkfs.vfat "$FRMW_LOOP"
788 mkfs.vfat "$FRMW_LOOP"
789 mkfs.ext4 "$ROOT_LOOP"
789 mkfs.ext4 "$ROOT_LOOP"
790
790
791 # Mount the temporary loop devices
791 # Mount the temporary loop devices
792 mkdir -p "$BUILDDIR/mount"
792 mkdir -p "$BUILDDIR/mount"
793 mount "$ROOT_LOOP" "$BUILDDIR/mount"
793 mount "$ROOT_LOOP" "$BUILDDIR/mount"
794
794
795 mkdir -p "$BUILDDIR/mount/boot/firmware"
795 mkdir -p "$BUILDDIR/mount/boot/firmware"
796 mount "$FRMW_LOOP" "$BUILDDIR/mount/boot/firmware"
796 mount "$FRMW_LOOP" "$BUILDDIR/mount/boot/firmware"
797
797
798 # Copy all files from the chroot to the loop device mount point directory
798 # Copy all files from the chroot to the loop device mount point directory
799 rsync -a "${R}/" "$BUILDDIR/mount/"
799 rsync -a "${R}/" "$BUILDDIR/mount/"
800
800
801 # Unmount all temporary loop devices and mount points
801 # Unmount all temporary loop devices and mount points
802 cleanup
802 cleanup
803
803
804 # Create block map file(s) of image(s)
804 # Create block map file(s) of image(s)
805 if [ "$ENABLE_SPLITFS" = true ] ; then
805 if [ "$ENABLE_SPLITFS" = true ] ; then
806 # Create block map files for "bmaptool"
806 # Create block map files for "bmaptool"
807 bmaptool create -o "$IMAGE_NAME-frmw.bmap" "$IMAGE_NAME-frmw.img"
807 bmaptool create -o "$IMAGE_NAME-frmw.bmap" "$IMAGE_NAME-frmw.img"
808 bmaptool create -o "$IMAGE_NAME-root.bmap" "$IMAGE_NAME-root.img"
808 bmaptool create -o "$IMAGE_NAME-root.bmap" "$IMAGE_NAME-root.img"
809
809
810 # Image was successfully created
810 # Image was successfully created
811 echo "$IMAGE_NAME-frmw.img ($(expr \( "${TABLE_SECTORS}" + "${FRMW_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
811 echo "$IMAGE_NAME-frmw.img ($(expr \( "${TABLE_SECTORS}" + "${FRMW_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
812 echo "$IMAGE_NAME-root.img ($(expr \( "${TABLE_SECTORS}" + "${ROOT_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
812 echo "$IMAGE_NAME-root.img ($(expr \( "${TABLE_SECTORS}" + "${ROOT_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
813 else
813 else
814 # Create block map file for "bmaptool"
814 # Create block map file for "bmaptool"
815 bmaptool create -o "$IMAGE_NAME.bmap" "$IMAGE_NAME.img"
815 bmaptool create -o "$IMAGE_NAME.bmap" "$IMAGE_NAME.img"
816
816
817 # Image was successfully created
817 # Image was successfully created
818 echo "$IMAGE_NAME.img ($(expr \( "${TABLE_SECTORS}" + "${FRMW_SECTORS}" + "${ROOT_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
818 echo "$IMAGE_NAME.img ($(expr \( "${TABLE_SECTORS}" + "${FRMW_SECTORS}" + "${ROOT_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
819
819
820 # Create qemu qcow2 image
820 # Create qemu qcow2 image
821 if [ "$ENABLE_QEMU" = true ] ; then
821 if [ "$ENABLE_QEMU" = true ] ; then
822 QEMU_IMAGE=${QEMU_IMAGE:=${BASEDIR}/qemu/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
822 QEMU_IMAGE=${QEMU_IMAGE:=${BASEDIR}/qemu/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
823 QEMU_SIZE=16G
823 QEMU_SIZE=16G
824
824
825 qemu-img convert -f raw -O qcow2 "$IMAGE_NAME".img "$QEMU_IMAGE".qcow2
825 qemu-img convert -f raw -O qcow2 "$IMAGE_NAME".img "$QEMU_IMAGE".qcow2
826 qemu-img resize "$QEMU_IMAGE".qcow2 $QEMU_SIZE
826 qemu-img resize "$QEMU_IMAGE".qcow2 $QEMU_SIZE
827
827
828 echo "$QEMU_IMAGE.qcow2 ($QEMU_SIZE)" ": successfully created"
828 echo "$QEMU_IMAGE.qcow2 ($QEMU_SIZE)" ": successfully created"
829 fi
829 fi
830 fi
830 fi
General Comments 0
Vous devez vous connecter pour laisser un commentaire. Se connecter maintenant